#!/usr/bin/perl

# USED PACKAGES
use NetSNMP::agent (':all');
use NetSNMP::ASN qw(ASN_OCTET_STR ASN_INTEGER ASN_GAUGE ASN_TIMETICKS ASN_COUNTER ASN_OBJECT_ID ASN_COUNTER64 ASN_IPADDRESS); 
use Net::SNMP;
use Data::Dumper qw(Dumper);
use LWP::UserAgent;
use JSON;

##################
# SOME FUNCTIONS #
##################

sub get_token { #one time check of interfaces

	my (%FORM) = @_;
	print "<h4>GET_TOKEN SUBROUTINE</h4>";
	#foreach my $key ( keys %FORM )
	#{
	#	my $value = $FORM{$key};
	#	print "$key : $value<br>";
	#}
	#print "<br>";

	
	if ( exists ($FORM{'username'}) && exists ($FORM{'controller_ip'}) && exists ($FORM{'password'}) )
	{
		my $url = 'https://' . $FORM{'controller_ip'} . ':8443/sdn/v2.0/auth';
		my $ua = LWP::UserAgent->new( ssl_opts => {
						verify_hostname => 0,
						SSL_verify_mode => 'SSL_VERIFY_NONE'
						} );
		my $response = $ua->post($url, 'Content' => '{"login":{"user":"' . $FORM{'username'} . '","password":"' . $FORM{'password'} . '","domain":"sdn"}}', 'Content-Type' => 'application/json');
		my $token;
		if ($response->is_success) {
                	my $json = $response->decoded_content;
	                $token = from_json ($json);
        	        $token = $token->{'record'}->{'token'};
			#print "<h2>TOKEN recieved: $token</h2>";
			return $token;
        	} else {
                	print "<h2>ERROR getting token :(, check IP or password</h2>";
        	}
	}
}

## this function I use to stransfer the whole FORM between pages 

sub generate_hidden_form_lines_from_hash {
	my (%hash) = @_;
        #print "<h4>GET_TOKEN SUBROUTINE</h4>";
        foreach my $key ( keys %hash )
        {
               my $value = $hash{$key};  
               print "<input type=\"hidden\" name=\"$key\" value=\"$value\">";
        }
        #print "<br>";
}
	
## Forumar LINK to 02_get_devices.cgi

sub get_devices {
	my (%hash) = @_;
	print "<FORM action=\"02_get_devices.cgi\" method=\"POST\">";
	generate_hidden_form_lines_from_hash(%hash);
	print "<input type=\"submit\" value=\"02_GET_ALL_DEVICES_AND_INTERFACES\"></FORM>";
}

## Forumar LINK to 03_get_nodes_and_kill_switch.cgi

sub get_nodes {
        my (%hash) = @_;
        print "<FORM action=\"03_get_nodes_and_kill.cgi\" method=\"POST\">";
        generate_hidden_form_lines_from_hash(%hash);
        print "<input type=\"submit\" value=\"03_GET_NODES_AND_KILL_SWITCH\"></FORM>";
}
	


###################################
# MAIN PART #######################
###################################
print "Content-type:text/html\r\n\r\n";
print '<html>';
print '<head>';
print '<title>Auth Token requestor</title>';
print '</head>';
print '<body>';
print '<h2>Enter controller IP / username / password!</h2>';

# Example FORM to enter data

print '<FORM method="POST">';
print 'Controller IP: <input type="text" name="controller_ip" value="192.168.125.9">  <br>';
print 'Username: <input type="text" name="username" value="sdn"><br>';
print 'Password: <input type="text" name="password" value="skyline"><br>';
print '<input type="submit" value="Submit">';
print '</FORM>';

# Example POST method processing

local ($buffer, @pairs, $pair, $name, $value, %FORM);
# Read in text
$ENV{'REQUEST_METHOD'} =~ tr/a-z/A-Z/;
if ($ENV{'REQUEST_METHOD'} eq "POST")
{
       read(STDIN, $buffer, $ENV{'CONTENT_LENGTH'});
     }else {
       $buffer = $ENV{'QUERY_STRING'};
} 

# Split information into name/value pairs to change it to a nice perl hash perl variable %FORM
@pairs = split(/&/, $buffer);
foreach $pair (@pairs)
{
   ($name, $value) = split(/=/, $pair);
   $value =~ tr/+/ /;
   $value =~ s/%(..)/pack("C", hex($1))/eg;
   $FORM{$name} = $value;
}

@keys = keys %FORM;
$form_size = @keys;

# now show/do something if something arrived from the formular

if ($form_size > 0)
{
	print "<h3>Your form input: $form_size</h3>";
	foreach my $key (keys %FORM)
	{
		print "$key: $FORM{$key}<br>";
	}

	# NOW THE ACTUAL REST API part
	if ( exists ($FORM{'username'}) && exists ($FORM{'controller_ip'}) && exists ($FORM{'password'}) )
	{
		print "Recieved username/controller_ip/password, continueing...";
		my $token = get_token(%FORM);
		if ($token == 1)
		{	
			goto END;
		}
		print "<h3>TOKEN recieved $token</h3>";
		
		$FORM{'token'} = $token;

		print "<h4>Now we unlock authenticated access to more functions</h4>";
		
		get_devices(%FORM);
		get_nodes(%FORM);
		
	}
	
}

#$first_name = $FORM{first_name};
#$last_name  = $FORM{last_name};

END:

print '</body>';
print '</html>';

1;