#!/usr/bin/perl

# PACKAGES
use LWP::UserAgent;
use JSON;

# GLOBAL STATIC VARIABLES / e.g CONFIGURATION
my  $COOKIE = "0x2031987"; #THIS IS A FLOW COOKIE THAT IDENTIFIES FLOWS ADDED BY THIS APPLICATION
my  $PRIORITY = "30000" ; #THIS IS A FLOW PRIORITY THIS PROGRAM SHOULD USE, FYI normally the PathDaemon generates priorities around 28k

# START OF HTML GENERATION
print "Content-type:text/html\r\n\r\n";
print '<html>';
print '<head>';
print '<title>Hello Word - First CGI Program</title>';
print '<link href=\'http://fonts.googleapis.com/css?family=Droid+Sans:400,700\' rel=\'stylesheet\' type=\'text/css\' />';
print '<link href=\'css/screen.css\' media=\'screen\' rel=\'stylesheet\' type=\'text/css\' />';
print '<link href=\'css/style.css\' rel=\'stylesheet\' type=\'text/css\' />';



print '</head>';
print '<body>';


###############################
## POST method processing #####
###############################

local ($buffer, @pairs, $pair, $name, $value, %FORM);
# Read in text
$ENV{'REQUEST_METHOD'} =~ tr/a-z/A-Z/;
if ($ENV{'REQUEST_METHOD'} eq "POST") 
{
       read(STDIN, $buffer, $ENV{'CONTENT_LENGTH'});
     }else {
       $buffer = $ENV{'QUERY_STRING'};
} 
  
# Split information into name/value pairs to change it to a nice perl hash perl variable %FORM
@pairs = split(/&/, $buffer);
foreach $pair (@pairs)
{
   ($name, $value) = split(/=/, $pair);
   $value =~ tr/+/ /;
   $value =~ s/%(..)/pack("C", hex($1))/eg;
   $FORM{$name} = $value;
}
 
@keys = keys %FORM;
$form_size = @keys;

# now show/do something if something arrived from the formular

if ($form_size > 0)
{
        if ( exists ($FORM{'username'}) && exists ($FORM{'controller_ip'}) && exists ($FORM{'password'}) && exists ($FORM{'token'}) )
        {
		print "<h4>Authentication token recieved ... </h4>";
		goto FILE_FUNCTION;
	}
	else
	{
		print "<h3>You missed comming to this file with authentication data, go back to 01_auth.cgi</h3>";
		goto END;
	}
}
else
{
	print "<h3>You missed comming to this file with authentication data, go back to 01_auth.cgi</h3>";
	goto END;
}

##############################
## END POST PROCESSING #######
##############################


##############
# FUNCTIONS ##
##############

## this function I use to stransfer the whole FORM between pages 

sub generate_hidden_form_lines_from_hash {
        my (%hash) = @_;
        #print "<h4>GET_TOKEN SUBROUTINE</h4>";
        foreach my $key ( keys %hash )
        {
               my $value = $hash{$key};
               print "<input type=\"hidden\" name=\"$key\" value=\"$value\">";
        }
        #print "<br>";
}

## Print all key/value pairs in a hash given
sub print_hash_in_table {   
        my (%hash) = @_;
	print '<table border=1>';
	foreach my $key ( keys %hash )
        {
               my $value = $hash{$key};  
               print "<tr><td>name=\"$key\"</td><td>value=\"$value\"</td></tr>";
        }
	print '</table><br>';
}


## this function will take argument of the node, argument of the form, and create for user a nice formular to enable blocking this particular node
sub kill_switch {
	my ($node, %FORM) = @_;
	print "Block for:<br>";
	print "<FORM  method=\"POST\">";
	generate_hidden_form_lines_from_hash(%FORM);
	print "<input type=\"hidden\" name=\"action\" value=\"block\">";
	print "<input type=\"hidden\" name=\"ip\" value=\"$node->{ip}\">";
	print "<input type=\"hidden\" name=\"mac\" value=\"$node->{mac}\">";
	print "<input type=\"hidden\" name=\"dpid\" value=\"$node->{dpid}\">";
	print "<input type=\"hidden\" name=\"port\" value=\"$node->{port}\">";
	print "Hard.Timeout:<input type=text name=hard value=300><br>";
	print "Idle.Timeout:<input type=text name=idle value=300><br>";
	print "<i>leave on 0 (zero) to make infinite</i><br>";
	print "<input type=\"submit\" value=\"BLOCK\"></FORM>";
}

sub unblock_button {
        my ($src_ip, $dpid, %FORM) = @_;
	print "UNBLOCK BUTTON:";
	print $src_ip;
	print $dpid;
        print "<FORM  method=\"POST\">";
        generate_hidden_form_lines_from_hash(%FORM);
	print "<input type=\"hidden\" name=\"action\" value=\"unblock\">";
        print "<input type=\"hidden\" name=\"ip\" value=\"$src_ip\">";
        print "<input type=\"hidden\" name=\"dpid\" value=\"$dpid\">";
        print "<input type=\"submit\" value=\"UNBLOCK\"></FORM>";        
}

## this will check all flows on the node neerest switch for flows made by this app (using cookie and source IP)
sub check_if_already_blocked {
        my ($node,%FORM) = @_;
        $url = 'https://' . $FORM{'controller_ip'} . ':8443/sdn/v2.0/of/datapaths/' . $node->{dpid} . '/flows';
        #print $url;
        my $ua = LWP::UserAgent->new( ssl_opts => {
                                verify_hostname => 0,
                                SSL_verify_mode => 'SSL_VERIFY_NONE'
                                } );            
        my $req = HTTP::Request->new(GET => $url);
        $req->header('content-type' => 'application/json');
        $req->header('x-auth-token' => $FORM{'token'});
        $response = $ua->request($req);
	if ($response->is_success) {
		my $status = 0; # 0 - UNBLOCKED / 1- BLOCKED
		my $json = $response->decoded_content;
                $flows = from_json($json);
		#print $json;
		$flow = $flows->{'flows'};
		#print "<br><br> $flow<br>";
		while (($key, $value) = each $flow){
			#print "Cookie: $value->{cookie}<br>COOKIE: $COOKIE<br>";
			$cookie_in_flow = $value->{cookie};
			if ($cookie_in_flow eq $COOKIE){
				#print "FOUND MY COOKIE! Check if for the same node";
				$march_array = $value->{match};
				while (($Match_key, $match_value) = each $march_array){
					#print "Rule source IP: $match_value->{ipv4_src}";
					if ( $match_value->{ipv4_src} eq $node->{ip} ){
						print "I have found my blocking rule! <br>It is in effect for: $value->{duration_sec}seconds.<br>";
						$status = 1;
						unblock_button("$node->{ip}","$node->{dpid}",%FORM);
					}
				}
			}
			
		}
		if ($status == 0){
			print "<font color=green>NOT BLOCKED</font>";
		}else{
			print "<font color=red>BLOCKED by this kick-ass application!</font>";
		}
	}else{
		print "ERROR: Failed to get switch flows!";
	}        

}

# This will simply create one refresh button to make table refreshes and not by mistake re-block again
sub non_block_refresh {
	my (%FORM) = @_;
	if ( ( exists ($FORM{'ip'}) || exists ($FORM{'mac'}) ) && exists ($FORM{'dpid'}) && exists ($FORM{'token'})) {
		delete $FORM{'ip'};
		delete $FORM{'mac'};
		delete $FORM{'dpid'};
	}
	print "<FORM  method=\"POST\">";
	generate_hidden_form_lines_from_hash(%FORM);
	print "<input type=\"submit\" value=\"REFRESH TABLE\"></FORM><i> This is to avoid you double-blocking with F5</i><br>";
}


FILE_FUNCTION:

	# LETS CHECK IF MAYBE THIS IS ALREADY A REFRESH WITH THE BLOCKING INSTRUCTION GIVEN
	if ( exists ($FORM{'action'}) && $FORM{'action'} eq "block" ) 
	{
		if ( ( exists ($FORM{'ip'}) || exists ($FORM{'mac'}) ) && exists ($FORM{'dpid'}) && exists ($FORM{'token'}))
		{
			print "<h4>BLOCKING INSTRUCTION RECIEVED</h4>";
		
			#Lets create the JSON representation of the block flow
			my $json = "{\"flow\":{\"cookie\": \"$COOKIE\",\"table_id\": 0,\"priority\": $PRIORITY,\"idle_timeout\": $FORM{'idle'},\"hard_timeout\": $FORM{'hard'},\"match\": [ {\"ipv4_src\": \"$FORM{'ip'}\"},{\"eth_type\": \"ipv4\"}	],\"instructions\": [{\"apply_actions\": []}] }}";
			print $json;
			$url = 'https://' . $FORM{'controller_ip'} . ':8443/sdn/v2.0/of/datapaths/' . $FORM{'dpid'} . '/flows';
			my $ua = LWP::UserAgent->new( ssl_opts => {     
                        	        verify_hostname => 0,   
                	                SSL_verify_mode => 'SSL_VERIFY_NONE'
        	                        } ); 	
			my $req = HTTP::Request->new(POST => $url);
	       	 	$req->header('content-type' => 'application/json');
        		$req->header('x-auth-token' => $FORM{'token'});
			$req->content( $json );
			$response = $ua->request($req);
			if ($response->is_success) { 
				print "<font color=green>SUCCESS! We are now blocking $FORM{'ip'}/$FORM{'mac'} on SWITCH $FORM{'dpid'} port $FORM{'port'} for $FORM{'hard'}/$FORM{'idle'} S/H Timeout</font>";
			}else{
				print "<font color=red>FAILED TO SEND BLOCKING FLOW!</font>";
			}
		}
	}
	if ( exists ($FORM{'action'}) && $FORM{'action'} eq "unblock" ) 
	{
		if (( exists ($FORM{'ip'}) || exists ($FORM{'mac'}) ) && exists ($FORM{'dpid'}) && exists ($FORM{'token'}))	
		{	
			print "<h4>UN-BLOCKING INSTRUCTION RECIEVED</h4>";
			
			#Lets create the JSON representation of the blocking flow
			my $json = "{\"flow\":{\"cookie\": \"$COOKIE\",\"table_id\": 0,\"priority\": $PRIORITY,\"match\": [ {\"ipv4_src\": \"$FORM{'ip'}\"},{\"eth_type\": \"ipv4\"}	],\"instructions\": [{\"apply_actions\": []}] }}";
			print $json;
			$url = 'https://' . $FORM{'controller_ip'} . ':8443/sdn/v2.0/of/datapaths/' . $FORM{'dpid'} . '/flows';
			my $ua = LWP::UserAgent->new( ssl_opts => {     
                        	        verify_hostname => 0,   
                	                SSL_verify_mode => 'SSL_VERIFY_NONE'
        	                        } ); 	
			my $req = HTTP::Request->new(DELETE => $url);
	       	 	$req->header('content-type' => 'application/json');
        		$req->header('x-auth-token' => $FORM{'token'});
			$req->content( $json );
			$response = $ua->request($req);
			if ($response->is_success) { 
				print "<font color=green>SUCCESS! We are now un-blocking $FORM{'ip'} on SWITCH $FORM{'dpid'}</font>";
			}else{
				print "<font color=red>FAILED TO SEND UN-BLOCKING REQUEST!</font>";
			}
		}
	}

	
	# DEFAULT FILE LOGIC STARTS HERE (e.g. MAIN PART WITH THE NODES TABLE)
        
	print "<h4>LISTING KNOWN NODES AND THEIR STATUS</h4>";
	$url = 'https://' . $FORM{'controller_ip'} . ':8443/sdn/v2.0/net/nodes';        
        print "$url";
	my $ua = LWP::UserAgent->new( ssl_opts => { 
                                verify_hostname => 0,   
                                SSL_verify_mode => 'SSL_VERIFY_NONE'
                                } );            
        my $req = HTTP::Request->new(GET => $url);
        $req->header('content-type' => 'application/json');
        $req->header('x-auth-token' => $FORM{'token'});
        $response = $ua->request($req);
        my $nodes;
	
        if ($response->is_success) {
                my $json = $response->decoded_content;
                $nodes = from_json($json);
                print_hash_in_table(%$nodes);
                $nodes2 = $nodes->{'nodes'};             
                #print_hash_in_table($nodes2);
		print "<h4>Table of all currently active network nodes, and the gread option to \"kill\" e.g. block them</h4>
                       <table border=1 padding=15px><tr><td>Device IP:</td><td>Device MAC:</td><td>Device hosting SWITCH:</td><td>PORT</td><td>is already BLOCKED?</td><td>BLOCK ACTIVATION</td></tr>";
		# REFRESH BUTTON HERE
		non_block_refresh(%FORM);
		while (($key, $node) = each $nodes2) {
		        print "<tr><td>$node->{ip}</td>";
		        print "<td>$node->{mac}</td>"; 
                        print "<td>$node->{dpid}</td>";                        
                        print "<td>$node->{port}</td>";                         
			print "<td>";
			check_if_already_blocked($node,%FORM);
			print "</td>";
			print "<td>";
			kill_switch($node,%FORM);
			print "</td></tr>";
		}
		print "</table>";	
	}	
        else {
                print "<h1>fuck!</h1>";
		goto WRONG_OUTPUT;
        }


        	


goto END;	
WRONG_OUTPUT:
	print "<h5>something went wrong, rather exiting ... </h5>";


END:


print '</body>';
print '</html>';

1;