#!/usr/bin/perl
#*
#* -------------------------------------------------------------------------------
#* "THE BEER-WARE LICENSE" (Revision 42):
#* Peter.Havrila@hp.com or phavrila@gmail.com wrote this file.  
#* As long as you retain this notice you can do whatever you want with this stuff. 
#* If we meet some day, and you think this stuff is worth it, you can buy me a 
#* beer in return.   
#*                                                            Peter Havrila, 2015
#*                                                            networkgeekstuff.com  
#* ------------------------------------------------------------------------------- 
#*/

# DEBUG PRINT ENABLING VARIABLE, MAKE THIS 1 to see much mode debug lines
$bDebug=0;

# USED PACKAGES
# use NetSNMP::agent (':all');
use NetSNMP::ASN qw(ASN_OCTET_STR ASN_INTEGER ASN_GAUGE ASN_TIMETICKS ASN_COUNTER ASN_OBJECT_ID ASN_COUNTER64 ASN_IPADDRESS); 
use Net::SNMP;
use Data::Dumper qw(Dumper);
use LWP::UserAgent;
use JSON;

##################
# SOME FUNCTIONS #
##################

sub dprint {
	my ($to_print) = @_;
	if ($bDebug==1){
		print "$to_print";
	}
}

sub get_token { #one time check of interfaces

	my (%FORM) = @_;
	dprint "<h4>GET_TOKEN SUBROUTINE:</h4>";
  dprint "FORM INPUT:<br>";
	foreach my $key ( keys %FORM )
	{
		my $value = $FORM{$key};
		dprint "$key : $value<br>";
	}
	dprint "<br><br>";

	
	if ( exists ($FORM{'username'}) && exists ($FORM{'controller_ip'}) && exists ($FORM{'controller_port'}) && exists ($FORM{'password'}) && exists ($FORM{'enterprise'}) )
	{
		my $url = 'https://'.$FORM{'controller_ip'}.':'.$FORM{'controller_port'}.'/nuage/api/v4_0/me';
  	#my $url = 'https://192.168.10.137:8443/nuage/api/v3_2/enterprises';
    
    #my $ua->default_header('Accept-Language' => "no, en")
    my $ua = LWP::UserAgent->new( ssl_opts => {
						verify_hostname => 0,
						SSL_verify_mode => 'SSL_VERIFY_NONE'
						} );
            
    ## add keys to keyring
    $ua->credentials(  # add this to our $browser 's "key ring"
      $FORM{'controller_ip'}.':'.$FORM{'controller_port'}, ## should be 8443, I just changed here
      'application',
      $FORM{'username'} => $FORM{'password'}
    );        
            
		#my $response = $ua->post($url, 'Content' => '{"login":{"user":"' . $FORM{'username'} . '","password":"' . $FORM{'password'} . '","domain":"sdn"}}', 'Content-Type' => 'application/json', 'X-Nuage-Organization' => ''.$FORM{'enterprise'}.'' );
    #my $response = $ua->post($url,'Content-Type' => 'application/json', 'X-Nuage-Organization' => 'csp','Content' => '{"login":{"user":"' . $FORM{'username'} . '","password":"' . $FORM{'password'} . '","X-Nuage-Organization":"csp"}}');
		my $response = $ua->get($url,'X-Nuage-Organization' => $FORM{'enterprise'},'Content-Type' => 'application/json');
    my $token;
		if ($response->is_success) {
                	dprint "success GET!!<br>";
                  my $json = $response->decoded_content;
	                $token = from_json ($json);
        	        
                  dprint "<h3>COMPLETE JSON RESPONSE (RAW):</h3>\n".$response->decoded_content;
                  
                  dprint "<h3>COMPLETE JSON RESPONSE (PRETTY):</h3>\n".JSON->new->pretty->encode(JSON->new->decode($response->decoded_content));
                  
                  $token = $token->[0]->{"APIKey"};
			            dprint "<h2>TOKEN recieved: ".$token."</h2>";
			            return $token;
        	} else {
                	print "<h2>ERROR getting token :(, check IP or password</h2>";
                  print $response->status_line;
        	}
	}
}

## this function I use to stransfer the whole FORM between pages 

sub generate_hidden_form_lines_from_hash {
	my (%hash) = @_;
        #print "<h4>GET_TOKEN SUBROUTINE</h4>";
        foreach my $key ( keys %hash )
        {
               my $value = $hash{$key};  
               print "<input type=\"hidden\" name=\"$key\" value=\"$value\">";
        }
        #print "<br>";
}
	
## Forumar LINK to 02_get_devices.cgi

sub get_devices {
	my (%hash) = @_;
	print "<FORM action=\"02_get_devices.cgi\" method=\"POST\">";
	generate_hidden_form_lines_from_hash(%hash);
	print "<input type=\"submit\" value=\"02_GET_ALL_DEVICES_AND_INTERFACES\"></FORM>";
}

## Forumar LINK to 03_get_nodes_and_kill_switch.cgi

sub get_nodes {
        my (%hash) = @_;
        print "<FORM action=\"03_get_nodes_and_kill.cgi\" method=\"POST\">";
        generate_hidden_form_lines_from_hash(%hash);
        print "<input type=\"submit\" value=\"03_GET_NODES_AND_KILL_SWITCH\"></FORM>";
}

sub main_menu {
        my (%hash) = @_;
        print "<FORM action=\"main.cgi\" method=\"POST\">";
        generate_hidden_form_lines_from_hash(%hash);    
        print "<input type=\"submit\" value=\"Continue to main menu ...\"></FORM>";
}	


###################################
# MAIN PART #######################
###################################
print "Content-type:text/html\r\n\r\n";
print '<html>';
print '<head>';
print '<title>Nuage Troll - Controller Login Page</title>';
print '<link href=\'http://fonts.googleapis.com/css?family=Droid+Sans:400,700\' rel=\'stylesheet\' type=\'text/css\' />';
print '<link href=\'css/screen.css\' media=\'screen\' rel=\'stylesheet\' type=\'text/css\' />';
print '<link href=\'css/style.css\' rel=\'stylesheet\' type=\'text/css\' />';
# http://jsfiddle.net/vfUvZ/
print '</head>';
print '<body>';

# Main structure table 
print '<p align=center>';
print '<table><tr><td colspan=2><p align="center">';
print '<img src="images/nuage-abuser-logo.png">';
print '<h2>Welcome to Nuage Troll!</h2>';
print 'Please enter your VSD node access and credentials';
print '</p></td></tr>';

# Example FORM to enter data

print '<FORM method="POST">';
print '<tr><td><p align="right">VSD IP address:</p></td><td><input type="text" name="controller_ip" value=""></td></tr>';
print '<tr><td><p align="right">VSD TCP Port:</p></td><td><input type="text" name="controller_port" value=""></td></tr>';
print '<tr><td><p align="right">Username:</p></td><td><input type="text" name="username" value="csproot"></td></tr>';
print '<tr><td><p align="right">Password:</p></td><td><input type="text" name="password" value="csproot"></td></tr>';
print '<tr><td><p align="right">Enterprise:</p></td><td><input type="text" name="enterprise" value="csp"></td></tr>';
print '<tr><td colspan=2><p align="center"><input type="submit" value="Submit"></p></td></tr>';
print '</FORM>';


# Example POST method processing

local ($buffer, @pairs, $pair, $name, $value, %FORM);
# Read in text
$ENV{'REQUEST_METHOD'} =~ tr/a-z/A-Z/;
if ($ENV{'REQUEST_METHOD'} eq "POST")
{
       read(STDIN, $buffer, $ENV{'CONTENT_LENGTH'});
     }else {
       $buffer = $ENV{'QUERY_STRING'};
} 

# Split information into name/value pairs to change it to a nice perl hash perl variable %FORM
@pairs = split(/&/, $buffer);
foreach $pair (@pairs)
{
   ($name, $value) = split(/=/, $pair);
   $value =~ tr/+/ /;
   $value =~ s/%(..)/pack("C", hex($1))/eg;
   $FORM{$name} = $value;
}

@keys = keys %FORM;
$form_size = @keys;

# Messages from the login process also go into last line of the table
print '<tr><td colspan=2><p align="center">';


# now show/do something if something arrived from the formular
if ($form_size > 0)
{
	dprint ("<h3>Your form input: $form_size</h3>");
	foreach my $key (keys %FORM)
	{
		dprint "$key: $FORM{$key}<br>";
	}

	# NOW THE ACTUAL REST API part
	if ( exists ($FORM{'username'}) && exists ($FORM{'controller_ip'}) && exists ($FORM{'password'}) &&  exists ($FORM{'controller_port'}) )
	{
		dprint "<Br>Recieved username/controller_ip/password, continueing...<br>";
		my $token = get_token(%FORM);
		if ($token == 1)
		{	
			goto END;
		}
		print "<h3>APIKey successfully recieved:<br><font color=green> $token</font></h3>";
		
		$FORM{'token'} = $token;
		
		#get_devices(%FORM);
		#get_nodes(%FORM);
		main_menu(%FORM);
	
		
	}
	
}

#$first_name = $FORM{first_name};
#$last_name  = $FORM{last_name};

goto SUCCESS;
END:
	printf "<h3><font color=red>X-Auth-Token NOT recieved! Check credentials or the vsd status.</font></h3>";


SUCCESS:
#end of last line of table
print '</p></td></tr>';


# Main structure table END
print "</table>";
print "</p>";



print '</body>';
print '</html>';

1;