#!/usr/bin/perl
#*
#* -------------------------------------------------------------------------------
#* "THE BEER-WARE LICENSE" (Revision 42):
#* Peter.Havrila@hp.com or phavrila@gmail.com wrote this file.  
#* As long as you retain this notice you can do whatever you want with this stuff. 
#* If we meet some day, and you think this stuff is worth it, you can buy me a 
#* beer in return.   
#*                                                            Peter Havrila, 2016
#*                                                            networkgeekstuff.com
#* -------------------------------------------------------------------------------
#*/

# Debugging trigger
$bDebug=0;

# Version
$version="Version 0.1a";

# PACKAGES
use LWP::UserAgent;
use JSON;

##############
# FUNCTIONS ##
##############

sub dprint {
        my ($to_print) = @_;
        if ($bDebug==1){
                print "$to_print";
        }
}

## this function I use to stransfer the whole FORM between pages 

sub generate_hidden_form_lines_from_hash {
        my (%hash) = @_;
        dprint "<h4>GENERATE_HIDDEN_FROM_LINES_HASH</h4>";
        foreach my $key ( keys %hash )
        {
               my $value = $hash{$key}; 
               print "<input type=\"hidden\" name=\"$key\" value=\"$value\">";
        }
        dprint "<br>";
}

# This will simply create one refresh button to make table refreshes and not by mistake re-block again
sub refresh_button {
        my (%FORM) = @_;
        print "<FORM  method=\"POST\">";
        $FORM{'action'}="none";
	generate_hidden_form_lines_from_hash(%FORM);
        print "<center><input type=\"image\" src=\"images/refresh-button_transparent.png\"></center></FORM>";
}


## Forumar LINK to ENTERPRISESES

sub get_enterprises {
        my (%hash) = @_;
        print "<FORM method=\"POST\">";
        generate_hidden_form_lines_from_hash(%hash);
	print "<input type=\"hidden\" name=\"view\" value=\"enterprises\">";
        print "<input type=\"submit\" value=\"Enterprises - list\"></FORM>";
}

## Forumar LINK to domains

sub get_domains {
        my (%hash) = @_;
        print "<FORM method=\"POST\">";
        generate_hidden_form_lines_from_hash(%hash);
	print "<input type=\"hidden\" name=\"view\" value=\"domains\">";
        print "<input type=\"submit\" value=\"Domains - list\"></FORM>";
}

## Forumar LINK to subnets

sub get_subnets {
        my (%hash) = @_;
        print "<FORM method=\"POST\">";
        generate_hidden_form_lines_from_hash(%hash);
	print "<input type=\"hidden\" name=\"view\" value=\"subnets\">";
        print "<input type=\"submit\" value=\"subnets - list\"></FORM>";
}

## Forumar LINK to zones

sub get_zones {
        my (%hash) = @_;
        print "<FORM method=\"POST\">";
        generate_hidden_form_lines_from_hash(%hash);
	print "<input type=\"hidden\" name=\"view\" value=\"zones\">";
        print "<input type=\"submit\" value=\"zones - list\"></FORM>";
}


## Forumar LINK to SWITCHES&INTERFACES

sub get_devices {
        my (%hash) = @_;
        print "<FORM method=\"POST\">";
        generate_hidden_form_lines_from_hash(%hash);
	print "<input type=\"hidden\" name=\"view\" value=\"switches_interfaces\">";
        print "<input type=\"submit\" value=\"Switches & Interfaces\"></FORM>";
}
 
## Forumar LINK to NODES LIST&KILL SWITCH

sub get_nodes {
        my (%hash) = @_;
        print "<FORM method=\"POST\">";
        generate_hidden_form_lines_from_hash(%hash);
	print "<input type=\"hidden\" name=\"view\" value=\"nodes_to_cut\">";
        print "<input type=\"submit\" value=\"Nodes to Cut\"></FORM>";
}

## Forumar LINK to NODES LIST&KILL SWITCH

sub get_readme {
        my (%hash) = @_;
        print "<FORM method=\"POST\">";
	delete $hash{'view'};
	delete $hash{'action'};
        generate_hidden_form_lines_from_hash(%hash);
	print "<input type=\"submit\" value=\"README & LIcense\"></FORM>";

}

## generates a HTML table out of provided %hash key/value pairs
sub print_hash_in_table {    
        my (%hash) = @_;                
        print '<table border=1>';
        foreach my $key ( keys %hash )
        {
               my $value = $hash{$key};
               print "<tr><td>name=\"$key\"</td><td>value=\"$value\"</td></tr>";
        }
        print '</table>';
}

###
# MAIN VIEWs FUNCTIONS
###

# Enterprisese
sub enterprises {
	my (%FORM) = @_;
	dprint "Starting \"Enterprises\" view generation<br>";
	print "<h1>Enterprises</h1>";
	print "<h5>In this view, the application will use REST API calls for nuage/api/v4_0/enterprises</h5>";	
	print "====================================================<br><br>";
	##################################
	# Retrieve the /net/devices list
	##################################
	print "<h2><strong>Table of REST API /nuage/api/v4_0/enterprises</strong></h2>";
	$url = 'https://' . $FORM{'controller_ip'} . ':'.$FORM{'controller_port'}.'/nuage/api/v4_0/enterprises';
	dprint "URL constructed: $url";
  
  
	# these options are to avoid the self-signed certificate problems
  my $ua = LWP::UserAgent->new( ssl_opts => {     
                          verify_hostname => 0,   
                          SSL_verify_mode => 'SSL_VERIFY_NONE'
                          } ); 
  ## add keys to keyring
  $ua->credentials(  # add this to our $browser 's "key ring"
    $FORM{'controller_ip'}.':'.$FORM{'controller_port'},
    'application',
    $FORM{'username'} => $FORM{'token'}
  );                                  
                                
                                
	my $req = HTTP::Request->new(GET => $url);
        $req->header('content-type' => 'application/json');
        $req->header('X-Nuage-Organization' => $FORM{'enterprise'});
        $response = $ua->request($req);
        my $devices;
	if (!($response->is_success)){
		goto WRONG_OUTPUT;
	}
	else
	{
		dprint "Successfully got $url from nuage!<br>";
		my $json = $response->decoded_content;
                $enterprises = from_json($json);       
    
    dprint "<h3>COMPLETE JSON RESPONSE (RAW):</h3>\n".$response->decoded_content;
                
		#this is to remove the outher most {} from the JSON that only has "devices":{}
    
    #####################################
    # We have /net/devices in my $devices
    # lets iterate via it with while(){}
    #####################################
      my $key;   
      my $enterprise;
     
     print "<h3>COMPLETE JSON RESPONSE:</h3>\n"; 
     
     foreach my $enterprise( @$enterprises ) { 
    
        while (($key, $enterprise_detail) = each %$enterprise) {
      	dprint "Iteration <strong>key:</strong> $key, <strong>value:</strong> $enterprise_detail<br>";
                    #before we start, I want the device UID and Status to be nicely starting the table:
        	if ($key eq "name"){
        		print "<h3><strong>Enterprise <font color=\"GREEN\">$device->{uid}</font> <font color=\"GREEN\">$enterprise_detail</font></strong></h3>";
        	}
        }
      }    

	
	}
}



# domains
sub domains {
	my (%FORM) = @_;
	dprint "Starting \"domains\" view generation<br>";
	print "<h1>domains</h1>";
	print "<h5>In this view, the application will use REST API calls for nuage/api/v4_0/domains</h5>";	
	print "====================================================<br><br>";
	##################################
	# Retrieve the /net/domains list
	##################################
	print "<h2><strong>Table of REST API /nuage/api/v4_0/domains</strong></h2>";
	$url = 'https://' . $FORM{'controller_ip'} . ':'.$FORM{'controller_port'}.'/nuage/api/v4_0/domains';
	dprint "URL constructed: $url";
  
  
	# these options are to avoid the self-signed certificate problems
  my $ua = LWP::UserAgent->new( ssl_opts => {     
                          verify_hostname => 0,   
                          SSL_verify_mode => 'SSL_VERIFY_NONE'
                          } ); 
  ## add keys to keyring
  $ua->credentials(  # add this to our $browser 's "key ring"
    $FORM{'controller_ip'}.':'.$FORM{'controller_port'},
    'application',
    $FORM{'username'} => $FORM{'token'}
  );                                  
                                
                                
	my $req = HTTP::Request->new(GET => $url);
        $req->header('content-type' => 'application/json');
        $req->header('X-Nuage-Organization' => $FORM{'enterprise'});
        $response = $ua->request($req);
        my $devices;
	if (!($response->is_success)){
		goto WRONG_OUTPUT;
	}
	else
	{
		dprint "Successfully got $url from nuage!<br>";
		my $json = $response->decoded_content;
                $enterprises = from_json($json);       
    
    dprint "<h3>COMPLETE JSON RESPONSE (RAW):</h3>\n".$response->decoded_content;
                
		#this is to remove the outher most {} from the JSON that only has "devices":{}
    
    #####################################
    # We have /net/devices in my $devices
    # lets iterate via it with while(){}
    #####################################
      my $key;   
      my $enterprise;
     
     print "<h3>COMPLETE JSON RESPONSE:</h3>\n"; 
     
     foreach my $enterprise( @$enterprises ) { 
    
        while (($key, $enterprise_detail) = each %$enterprise) {
      	dprint "Iteration <strong>key:</strong> $key, <strong>value:</strong> $enterprise_detail<br>";
                    #before we start, I want the device UID and Status to be nicely starting the table:
        	if ($key eq "name"){
        		print "<h3><strong>Domains <font color=\"GREEN\">$device->{uid}</font> <font color=\"GREEN\">$enterprise_detail</font></strong></h3>";
        	}
        }
      }    

	
	}
}


# zones
sub zones {
	my (%FORM) = @_;
	dprint "Starting \"zones\" view generation<br>";
	print "<h1>zones</h1>";
	print "<h5>In this view, the application will use REST API calls for nuage/api/v4_0/zones</h5>";	
	print "====================================================<br><br>";
	##################################
	# Retrieve the /net/zones list
	##################################
	print "<h2><strong>Table of REST API /nuage/api/v4_0/zones</strong></h2>";
	$url = 'https://' . $FORM{'controller_ip'} . ':'.$FORM{'controller_port'}.'/nuage/api/v4_0/zones';
	dprint "URL constructed: $url";
  
  
	# these options are to avoid the self-signed certificate problems
  my $ua = LWP::UserAgent->new( ssl_opts => {     
                          verify_hostname => 0,   
                          SSL_verify_mode => 'SSL_VERIFY_NONE'
                          } ); 
  ## add keys to keyring
  $ua->credentials(  # add this to our $browser 's "key ring"
    $FORM{'controller_ip'}.':'.$FORM{'controller_port'},
    'application',
    $FORM{'username'} => $FORM{'token'}
  );                                  
                                
                                
	my $req = HTTP::Request->new(GET => $url);
        $req->header('content-type' => 'application/json');
        $req->header('X-Nuage-Organization' => $FORM{'enterprise'});
        $response = $ua->request($req);
        my $devices;
	if (!($response->is_success)){
		goto WRONG_OUTPUT;
	}
	else
	{
		dprint "Successfully got $url from nuage!<br>";
		my $json = $response->decoded_content;
                $enterprises = from_json($json);       
    
    dprint "<h3>COMPLETE JSON RESPONSE (RAW):</h3>\n".$response->decoded_content;
                
		#this is to remove the outher most {} from the JSON that only has "devices":{}
    
    #####################################
    # We have /net/devices in my $devices
    # lets iterate via it with while(){}
    #####################################
      my $key;   
      my $enterprise;
     
     print "<h3>COMPLETE JSON RESPONSE:</h3>\n"; 
     
     foreach my $enterprise( @$enterprises ) { 
    
        while (($key, $enterprise_detail) = each %$enterprise) {
      	dprint "Iteration <strong>key:</strong> $key, <strong>value:</strong> $enterprise_detail<br>";
                    #before we start, I want the device UID and Status to be nicely starting the table:
        	if ($key eq "name"){
        		print "<h3><strong>Zones <font color=\"GREEN\">$device->{uid}</font> <font color=\"GREEN\">$enterprise_detail</font></strong></h3>";
        	}
        }
      }    

	
	}
}

# subnets
sub subnets {
	my (%FORM) = @_;
	dprint "Starting \"subnets\" view generation<br>";
	print "<h1>subnets</h1>";
	print "<h5>In this view, the application will use REST API calls for nuage/api/v4_0/subnets</h5>";	
	print "====================================================<br><br>";
	##################################
	# Retrieve the /net/subnets list
	##################################
	print "<h2><strong>Table of REST API /nuage/api/v4_0/subnets</strong></h2>";
	$url = 'https://' . $FORM{'controller_ip'} . ':'.$FORM{'controller_port'}.'/nuage/api/v4_0/subnets';
	dprint "URL constructed: $url";
  
  
	# these options are to avoid the self-signed certificate problems
  my $ua = LWP::UserAgent->new( ssl_opts => {     
                          verify_hostname => 0,   
                          SSL_verify_mode => 'SSL_VERIFY_NONE'
                          } ); 
  ## add keys to keyring
  $ua->credentials(  # add this to our $browser 's "key ring"
    $FORM{'controller_ip'}.':'.$FORM{'controller_port'},
    'application',
    $FORM{'username'} => $FORM{'token'}
  );                                  
                                
                                
	my $req = HTTP::Request->new(GET => $url);
        $req->header('content-type' => 'application/json');
        $req->header('X-Nuage-Organization' => $FORM{'enterprise'});
        $response = $ua->request($req);
        my $devices;
	if (!($response->is_success)){
		goto WRONG_OUTPUT;
	}
	else
	{
		dprint "Successfully got $url from nuage!<br>";
		my $json = $response->decoded_content;
                $enterprises = from_json($json);       
    
    dprint "<h3>COMPLETE JSON RESPONSE (RAW):</h3>\n".$response->decoded_content;
                
		#this is to remove the outher most {} from the JSON that only has "devices":{}
    
    #####################################
    # We have /net/devices in my $devices
    # lets iterate via it with while(){}
    #####################################
      my $key;   
      my $enterprise;
     
     print "<h3>COMPLETE JSON RESPONSE:</h3>\n"; 
     
     foreach my $enterprise( @$enterprises ) { 
    
        while (($key, $enterprise_detail) = each %$enterprise) {
      	dprint "Iteration <strong>key:</strong> $key, <strong>value:</strong> $enterprise_detail<br>";
                    #before we start, I want the device UID and Status to be nicely starting the table:
        	if ($key eq "name"){
        		print "<h3><strong>Subnets <font color=\"GREEN\">$device->{uid}</font> <font color=\"GREEN\">$enterprise_detail</font></strong></h3>";
        	}
        }
      }    

	
	}
}




#################
## FUNCTIONS END
#################

# START OF HTML GENERATION
print "Content-type:text/html\r\n\r\n";
print '<html>';
print '<head>';
print '<title>Nuage Troll - REST API alternative interface</title>';
print '<link href=\'http://fonts.googleapis.com/css?family=Droid+Sans:400,700\' rel=\'stylesheet\' type=\'text/css\' />';
print '<link href=\'css/screen.css\' media=\'screen\' rel=\'stylesheet\' type=\'text/css\' />';
print '<link href=\'css/style.css\' rel=\'stylesheet\' type=\'text/css\' />';
print '</head>';
print '<body>';

###############################
## POST method processing #####
###############################

local ($buffer, @pairs, $pair, $name, $value, %FORM);
# Read in text
$ENV{'REQUEST_METHOD'} =~ tr/a-z/A-Z/;
if ($ENV{'REQUEST_METHOD'} eq "POST") 
{
       read(STDIN, $buffer, $ENV{'CONTENT_LENGTH'});
     }else {
       $buffer = $ENV{'QUERY_STRING'};
} 
  
# Split information into name/value pairs to change it to a nice perl hash perl variable %FORM
@pairs = split(/&/, $buffer);
foreach $pair (@pairs)
{
   ($name, $value) = split(/=/, $pair);
   $value =~ tr/+/ /;
   $value =~ s/%(..)/pack("C", hex($1))/eg;
   $FORM{$name} = $value;
}
 
@keys = keys %FORM;
$form_size = @keys;

# now show/do something if something arrived from the formular

if ($form_size > 0)
{

        if ( exists ($FORM{'token'}) )
        {
                dprint "<h4>ONLY Authentication token recieved ... </h4>";
        }

        if ( exists ($FORM{'username'}) && exists ($FORM{'controller_ip'}) && exists ($FORM{'password'}) && exists ($FORM{'token'}) )
        {
                dprint "<h4>Authentication token recieved ... </h4>";
        }
        else
        {   
                print "<h3>You missed comming to this file with authentication data, go back to 01_auth.cgi</h3>";
                print '<meta http-equiv="refresh" content="0;url=index.cgi">';
                goto END;
        }
}
else
{   
        print "<h3>You missed comming to this file with authentication data, go back to 01_auth.cgi</h3>";
        print '<meta http-equiv="refresh" content="0;url=index.cgi">';
        goto END;
}


##############################
## END POST PROCESSING #######
##############################



#####################################
## CHECK FOR ACTION ORDERS IN POST ##
#####################################

# BLOCK NODE
if ( exists ($FORM{'action'}) && $FORM{'action'} eq "block" )
{
	dprint "BLOCKING FUNCTION START";
	block(%FORM);
	$FORM{'action'}="none";
	
}

# UNBLOCK NODE
if ( exists ($FORM{'action'}) && $FORM{'action'} eq "unblock" )
{
	dprint "UN-BLOCKING FUNCTION START";
	unblock(%FORM);
	$FORM{'action'}="none";
}


################################
## MAIN BODY TABLE RENDER ######
################################
# Start of table, with main menu

print '<table><tr><td valign=top width=265px bgcolor=#8b9cae>';


######################
## Main menu render ##
######################
print '<p align=center valign=top><img width="200px" src="images/nuage-abuser-logo.png"></p>';
print '<p align=center><font size=5>Nuage Troll</font></p>';
print '==================================';
print '<center>ALternative REST API GUI</center>';
print '==================================';

print '<br><strong>Main Views:</strong><br>';
print '<center>';
#get_nodes(%FORM);
print '</center>';

print '----------------------------------------------------------<br>';
print '<strong>Read-Only Views:</strong><br>';
print '<center>';
get_enterprises(%FORM);
get_domains(%FORM);
get_zones(%FORM);
get_subnets(%FORM);
print '<br>';
get_readme(%FORM);
print '</center>';

print '----------------------------------------------------------<br>';
print '<strong>Safe-refresh button:</strong><br>Helps avoid double-action on F5 refresh';

# REFRESH BUTTONE
refresh_button(%FORM);

print "$version<br>";
print "X-Auth-Token used:<br>$FORM{'token'}";

################################
## MAIN BODY TABLE RENDER ######
################################
# switch between main menu and main view content
print '</td><td valign=top>';

########################################0
## CHECK FOR MAIN VIEW SELECTION #######
########################################
#TODO
my $default_view = 1;
dprint $FORM{'view'};

if ( exists ($FORM{'view'}) && $FORM{'view'} eq "enterprises" )
{
	$default_view=0;
	enterprises(%FORM);
	#TODO
	
}

if ( exists ($FORM{'view'}) && $FORM{'view'} eq "domains" )
{
	$default_view=0;
	domains(%FORM);
	#TODO
	
}

if ( exists ($FORM{'view'}) && $FORM{'view'} eq "subnets" )
{
	$default_view=0;
	subnets(%FORM);
	#TODO
	
}

if ( exists ($FORM{'view'}) && $FORM{'view'} eq "zones" )
{
	$default_view=0;
	zones(%FORM);
	#TODO
	
}


if ($default_view == 1){
	print "<iframe id=\"myFrame\" src=\"README.html\" width=\"600\" height=\"600\"></iframe>";
}

################################
## MAIN BODY TABLE RENDER ######
################################
# CLOSE WHOLE TABLE WITH Copyright
print '</td></tr><tr><td colspan=2>';
#print '<p align=center>Copyright(c) Peter Havrila, 2016, All Rights Reserverd</p>';
print '</td></tr></table>';

################################
## ERROR HANDLING ##############
################################
goto END; # jump over this section

WRONG_OUTPUT:
    dprint "<h1>WRONG_OUTPUT</h1>";	

END:
################################
## HTML BODY CLOSE #############
################################

print '</body>';
print '</html>';

1;
